from BitTorrent.defaultargs import common_options, rare_options, MYTRUE, MYFALSE, MyBool
import os, cPickle

qtorrent_options = \
    [
	('filesystem_encoding', '',
		_("character encoding used on the local filesystem. "
		  "If left empty, autodetected. "
		  "Autodetection doesn't work under python versions older than 2.3")),
	('auto_save_by_default', MYFALSE,
		_("wether or not to make auto-save the default option when adding torrents from the command line")),
	('auto_save_to', '~/.qtorrent3/incoming',
		_("where to auto-save files to")),
	('enable_web_interface', MYTRUE,
		_("start the web interface when qtorrent starts")),
	('web_interface_password', '',
		_("password for the web interface. web interface won't start if this is empty")),
    ]

ADDITIONAL = \
    {
	'max_uploads': 6,
	'data_dir': os.path.expanduser('~/.qtorrent3'),
    }

from UserDict import UserDict
class Config(UserDict):
	def __init__(self):
		UserDict.__init__(self)
		self._defaults = {}
		for key, default, descr in common_options + rare_options + qtorrent_options:
			self._defaults[key] = default
		self._defaults.update(ADDITIONAL)
		self.load()
	
	def save(self):
		config = {}
		for key, val in self.items():
			if val != self._defaults[key]:
				config[key] = val
		cPickle.dump(config, open(os.path.expanduser("~/.qtorrent3/config"), "w"))
	
	def load(self):
		self.clear()
		self.update(self._defaults)
		try:
			config = cPickle.load(open(os.path.expanduser('~/.qtorrent3/config')))
			self.update(config)
		except IOError:
			print 'Warning: could not load configuration, using defaults'
		except cPickle.UnpicklingError:
			print 'Warning: corrupted or invalid configuration, using defaults'
		except EOFError:
			print 'Warning: truncated configuration, using defaults'
